/*  
''    Script Name: DefocusSS
''    Author: okuno hiroyuki
''    Last Updated: Jan 29, 2007
''   
''    (c) Sweetberry Studio 2007
''    mail: hiro@sweetberry.com
''    */



image DefocusSS(
image In=0,
float Iris=0,
float IrisAngle=0,
float boost=1,
int Shape=6,
int Width=width,
int Height=height,
float sensitivity=1.05

)
{
	float boostPoint =boost;
	float Iris2=Iris+1;
	float Q_Div;
	float IrisK;
	float mixP=0;
	
	if (Iris2<3){
		IrisK=1;
		IrisK2=1;
		if(Shape==6){
			kernel="Hexagon1";
			kernel2="Hexagon1";
		}else if(Shape==0){
			kernel="circle1";
			kernel2="circle1";
		}
		mixP=0;
	}else if(Iris2<6){
		IrisK=1;
		IrisK2=3;
		if(Shape==6){
			kernel="Hexagon1";
			kernel2="Hexagon3";
		}else if(Shape==0){
			kernel="circle1";
			kernel2="circle3";
		}
		mixP=(Iris2-3)*33.3333;
	}else if(Iris2<10){
		IrisK=3;
		IrisK2=5;
		if(Shape==6){
			kernel="Hexagon3";
			kernel2="Hexagon5";
		}else if(Shape==0){
			kernel="circle3";
			kernel2="circle5";
		}
		mixP=(Iris2-6)*25;

	}else if(Iris2<18){
		IrisK=5;
		IrisK2=9;
		if(Shape==6){
			kernel="Hexagon5";
			kernel2="Hexagon9";
		}else if(Shape==0){
			kernel="circle5";
			kernel2="circle9";
		}
		mixP=(Iris2-10)*12.5;
	}else if(Iris2<34){
		IrisK=9;
		IrisK2=17;
		if(Shape==6){
			kernel="Hexagon9";
			kernel2="Hexagon17";
		}else if(Shape==0){
			kernel="circle9";
			kernel2="circle17";
		}
		mixP=(Iris2-18)*6.25;
	}else {
		IrisK=17;
		IrisK2=33;
		if(Shape==6){
			kernel="Hexagon17";
			kernel2="Hexagon33";
		}else if(Shape==0){
			kernel="circle17";
			kernel2="circle33";
		}
		mixP=(Iris2-34)*3.125;
	}
	Q_Div=Iris2/IrisK;
	Q_Div2=Iris2/IrisK2;

//

    Bytes1 = Bytes(In, 4);

	CCrop1 = CCrop(Bytes1, 0, 0, 1, height);
	CCrop2 = CCrop(Bytes1, width-1, 0, width, height);
	Resize1 = Resize(CCrop1, Iris2*10, height, "gauss", 0);
	Resize2 = Resize(CCrop2, Iris2*10, height, "gauss", 0);
	Move2DL = Move2D(Resize1, -width, 0, 0, 1, 1, xScale, 0, 0, width/2, height/2, "gauss", xFilter, "trsx", 0, 0, 0.5, 0, 0, time);
	BlurL = Blur(Move2DL, 0, 50, 0, "gauss", xFilter, "rgba");
	Move2DR = Move2D(Resize2, Width, 0, 0, 1, 1, xScale, 0, 0, 0, height/2, "gauss", xFilter, "trsx", 0, 0, 0.5, 0, 0, time);
	BlurR = Blur(Move2DR, 0, 50, 0, "gauss", xFilter, "rgba");
	Over1 = Over(Bytes1, BlurL, 0, 0, 0);
	Over2 = Over(Over1, BlurR, 0, 0, 0);
	CCrop3 = CCrop(Over2, -Iris2*10, 0, width+Iris2*10, 1);
	CCrop4 = CCrop(Over2, -Iris2*10, height-1, width+Iris2*10, height);
	Resize3 = Resize(CCrop3, width, Iris2*10, "gauss", 0);
	Resize4 = Resize(CCrop4, width, Iris2*10, "gauss", 0);
	Move2DB = Move2D(Resize3, -height, -height, 0, 1, 1, xScale, 0, 0, 0, height/2, "gauss", xFilter, "trsx", 0, 0, 0.5, 0, 0, time);
	BlurB = Blur(Move2DB, 50, 0, 1, "gauss", xFilter, "rgba");
	Move2DT = Move2D(Resize4, -height, Height, 0, 1, 1, xScale, 0, 0, 0, 0, "gauss", xFilter, "trsx", 0, 0, 0.5, 0, 0, time);
	BlurT = Blur(Move2DT, 50, 0, 1, "gauss", xFilter, "rgba");
	Over3 = Over(Over2, BlurB, 0, 0, 0);
	Over4 = Over(Over3, BlurT, 0, 0, 0);
	//CCropQ = CCrop(Over4, -100, -100, width+100, height+100);
    Move2D1 = Move2D(Over4, 0, 0, IrisAngle, 1, 1/Q_Div, xScale, 0, 0, width/2, height/2, "gauss", xFilter, "trsx", 0, 0, 0.5, 0, 0, time);
    ColorX1 = ColorX(Move2D1, pow(sensitivity,r*255), pow(sensitivity,g*255), pow(sensitivity,b*255), pow(sensitivity,a*255), z);
	Gamma1 = Gamma(ColorX1, 1/boostPoint, rGamma, rGamma, 1);
    Convolve1 = Convolve(Gamma1, "rgba", kernel, 100, 0);
	Gamma2 = Gamma(Convolve1, boostPoint, rGamma, rGamma, 1);
    ColorX2 = ColorX(Gamma2, log(r)/log(sensitivity)/255, log(g)/log(sensitivity)/255, log(b)/log(sensitivity)/255, log(a)/log(sensitivity)/255, z);
	Move2D2 = Move2D(ColorX2, 0, 0, -IrisAngle, 1, Q_Div, xScale, 0, 0, width/2, height/2, "gauss", xFilter, "rtsx", 0, 0, 0.5, 0, 0, time);
	
	Move2D3 = Move2D(Over4, 0, 0, IrisAngle, 1, 1/Q_Div2, xScale, 0, 0, width/2, height/2, "gauss", xFilter, "trsx", 0, 0, 0.5, 0, 0, time);
    ColorX3 = ColorX(Move2D3, pow(sensitivity,r*255), pow(sensitivity,g*255), pow(sensitivity,b*255), pow(sensitivity,a*255), z);
	Gamma3 = Gamma(ColorX3, 1/boostPoint, rGamma, rGamma, 1);
    Convolve2 = Convolve(Gamma3, "rgba", kernel2, 100, 0);
	Gamma4 = Gamma(Convolve2, boostPoint, rGamma, rGamma, 1);
    ColorX4 = ColorX(Gamma4, log(r)/log(sensitivity)/255, log(g)/log(sensitivity)/255, log(b)/log(sensitivity)/255, log(a)/log(sensitivity)/255, z);
    Move2D4 = Move2D(ColorX4, 0, 0, -IrisAngle, 1, Q_Div2, xScale, 0, 0, width/2, height/2, "gauss", xFilter, "rtsx", 0, 0, 0.5, 0, 0, time);
 
	Mix1 = Mix(Move2D2, Move2D4, 1, mixP, "rgba");

    return Mix1;
}


DefKernel(
    "Hexagon33",
    33, 33,
    1/1089.0,
    0,
    0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.027, 0.439, 0.835, 0.439, 0.027, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.275, 0.780, 1.000, 1.000, 1.000, 0.780, 0.275, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.157, 0.647, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.647, 0.157, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.067, 0.506, 0.937, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.937, 0.506, 0.067, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.357, 0.843, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.843, 0.357, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.216, 0.722, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.722, 0.216, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000, 0.000, 0.106, 0.584, 0.980, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.980, 0.584, 0.106, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.043, 0.431, 0.902, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.902, 0.431, 0.043, 0.000, 0.000,
	0.000, 0.000, 0.588, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.588, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.694, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694, 0.000, 0.000,
	0.000, 0.000, 0.588, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.588, 0.000, 0.000,
	0.000, 0.000, 0.043, 0.431, 0.902, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.902, 0.431, 0.043, 0.000, 0.000,
	0.000, 0.000, 0.000, 0.000, 0.106, 0.584, 0.980, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.980, 0.584, 0.106, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.216, 0.722, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.722, 0.216, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.357, 0.843, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.843, 0.357, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.067, 0.506, 0.937, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.937, 0.506, 0.067, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.157, 0.647, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.647, 0.157, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.275, 0.780, 1.000, 1.000, 1.000, 0.780, 0.275, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
    0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.027, 0.439, 0.835, 0.439, 0.027, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000
);

DefKernel(
    "Hexagon17",
    17, 17,
    1/289.0,
    0,
    0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.027, 0.443, 0.839, 0.443, 0.027, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
    0.000, 0.000, 0.000, 0.000, 0.000, 0.286, 0.776, 1.000, 1.000, 1.000, 0.776, 0.286, 0.000, 0.000, 0.000, 0.000, 0.000,
    0.000, 0.000, 0.000, 0.169, 0.651, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.651, 0.169, 0.000, 0.000, 0.000,
    0.000, 0.082, 0.510, 0.945, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.945, 0.510, 0.082, 0.000,
    0.000, 0.690, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.690, 0.000,
    0.000, 0.792, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.792, 0.000,
    0.000, 0.792, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.792, 0.000,
    0.000, 0.792, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.792, 0.000,
    0.000, 0.792, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.792, 0.000,
    0.000, 0.792, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.792, 0.000,
    0.000, 0.792, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.792, 0.000,
    0.000, 0.792, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.792, 0.000,
    0.000, 0.690, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.690, 0.000,
    0.000, 0.082, 0.510, 0.945, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.945, 0.510, 0.082, 0.000,
	0.000, 0.000, 0.000, 0.169, 0.651, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.651, 0.169, 0.000, 0.000, 0.000,
    0.000, 0.000, 0.000, 0.000, 0.000, 0.286, 0.776, 1.000, 1.000, 1.000, 0.776, 0.286, 0.000, 0.000, 0.000, 0.000, 0.000,
    0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.027, 0.443, 0.839, 0.443, 0.027, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000
);

DefKernel(
    "Hexagon9",
    9, 9,
    1/81.0,
    0,
    0.000, 0.000, 0.000, 0.443, 0.843, 0.443, 0.000, 0.000, 0.000,
    0.000, 0.290, 0.776, 1.000, 1.000, 1.000, 0.776, 0.290, 0.000,
    0.310, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.310,
    0.388, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.388,
    0.388, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.388,
    0.388, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.388,
    0.310, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.310,
    0.000, 0.290, 0.776, 1.000, 1.000, 1.000, 0.776, 0.290, 0.000,
    0.000, 0.000, 0.000, 0.443, 0.843, 0.443, 0.000, 0.000, 0.000
);

DefKernel(
    "Hexagon5",
    5, 5,
    1/25.0,
    0,
    0.047, 0.443, 0.843, 0.000, 0.047,
    0.569, 1.000, 1.000, 1.000, 0.569,
    0.686, 1.000, 1.000, 1.000, 0.686,
    0.569, 1.000, 1.000, 1.000, 0.569,
    0.047, 0.443, 0.843, 0.000, 0.047
);

DefKernel(
    "Hexagon3",
    3, 3,
    1/9.0,
    0,
    0.412, 0.839, 0.412,
    0.855, 1.000, 0.855,
    0.412, 0.839, 0.412
);

DefKernel(
    "Hexagon1",
    1, 1,
    1/1.0,
    0,
	0.671
);


DefKernel(
    "circle33",
    33, 33,
    1/1089.0,
    0,
	0.000, 0.000, 0.000 ,0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.012, 0.196, 0.447, 0.686, 0.863, 0.976, 1.000, 0.976, 0.863, 0.686, 0.447, 0.196, 0.012, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000 ,0.000, 0.000, 0.000, 0.000, 0.000, 0.035, 0.361, 0.796, 0.996, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.996, 0.796, 0.361, 0.035, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000 ,0.000, 0.000, 0.000, 0.000, 0.294, 0.808, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.808, 0.294, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000 ,0.000, 0.000, 0.012, 0.537, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.537, 0.012, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000 ,0.000, 0.039, 0.682, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.682, 0.039, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000 ,0.016, 0.682, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.682, 0.016, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000 ,0.537, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.537, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.373 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.373, 0.000, 0.000,
	0.000, 0.075, 0.827 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.827, 0.075, 0.000,
	0.000, 0.357, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.357, 0.000,
	0.024, 0.812, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.812, 0.024,
	0.188, 1.000, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.188,
	0.447, 1.000, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.447,
	0.694, 1.000, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694,
	0.871, 1.000, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.871,
	0.981, 1.000, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.981,
	1.000, 1.000, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,
	0.981, 1.000, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.981,
	0.871, 1.000, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.871,
	0.694, 1.000, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.694,
	0.447, 1.000, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.447,
	0.188, 1.000, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.188,
	0.024, 0.812, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.812, 0.024,
	0.000, 0.357, 1.000 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.357, 0.000,
	0.000, 0.075, 0.827 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.827, 0.075, 0.000,
	0.000, 0.000, 0.373 ,1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.373, 0.000, 0.000,
	0.000, 0.000, 0.000 ,0.537, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.537, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000 ,0.016, 0.682, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.682, 0.016, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000 ,0.000, 0.039, 0.682, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.682, 0.039, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000 ,0.000, 0.000, 0.012, 0.537, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.537, 0.012, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000 ,0.000, 0.000, 0.000, 0.000, 0.294, 0.808, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.808, 0.294, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000 ,0.000, 0.000, 0.000, 0.000, 0.000, 0.035, 0.361, 0.796, 0.996, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.996, 0.796, 0.361, 0.035, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,
	0.000, 0.000, 0.000 ,0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.012, 0.196, 0.447, 0.686, 0.863, 0.976, 1.000, 0.976, 0.863, 0.686, 0.447, 0.196, 0.012, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000
	);

DefKernel(
    "circle17",
    17, 17,
    1/289.0,
    0,
    0.000, 0.000, 0.000, 0.000, 0.078, 0.427, 0.725, 0.937, 1.000, 0.937, 0.725, 0.427, 0.078, 0.000, 0.000, 0.000, 0.000,
    0.000, 0.000, 0.000, 0.357, 0.859, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.859, 0.357, 0.000, 0.000, 0.000,
    0.000, 0.000, 0.467, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.467, 0.000, 0.000,
    0.000, 0.349, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.349, 0.000,
    0.078, 0.886, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.886, 0.078,
    0.435, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.435,
    0.741, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.741,
    0.941, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.941,
    1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000,
    0.941, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.941,
    0.741, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.741,
    0.435, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.435,
	0.078, 0.886, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.886, 0.078,
	0.000, 0.349, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.349, 0.000,
    0.000, 0.000, 0.467, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.467, 0.000, 0.000,
    0.000, 0.000, 0.000, 0.357, 0.859, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.859, 0.357, 0.000, 0.000, 0.000,
    0.000, 0.000, 0.000, 0.000, 0.078, 0.427, 0.725, 0.937, 1.000, 0.937, 0.725, 0.427, 0.078, 0.000, 0.000, 0.000, 0.000
	);

DefKernel(
    "circle9",
    9, 9,
    1/81.0,
    0,
    0.000, 0.059, 0.498, 0.871, 1.000, 0.871, 0.498, 0.059, 0.000,
	0.059, 0.733, 1.000, 1.000, 1.000, 1.000, 1.000, 0.733, 0.059,
	0.510, 0.733, 1.000, 1.000, 1.000, 1.000, 1.000, 0.733, 0.510,
	0.890, 0.733, 1.000, 1.000, 1.000, 1.000, 1.000, 0.733, 0.890,
	1.000, 0.733, 1.000, 1.000, 1.000, 1.000, 1.000, 0.733, 1.000,
	0.890, 0.733, 1.000, 1.000, 1.000, 1.000, 1.000, 0.733, 0.890,
	0.510, 0.733, 1.000, 1.000, 1.000, 1.000, 1.000, 0.733, 0.510,
	0.059, 0.733, 1.000, 1.000, 1.000, 1.000, 1.000, 0.733, 0.059,
    0.000, 0.059, 0.498, 0.871, 1.000, 0.871, 0.498, 0.059, 0.000
);

DefKernel(
    "circle5",
    5, 5,
    1/25.0,
    0,
    0.145, 0.757, 1.000, 0.757, 0.145,
    0.784, 1.000, 1.000, 1.000, 0.784,
    1.000, 1.000, 1.000, 1.000, 1.000,
    0.784, 1.000, 1.000, 1.000, 0.784,
    0.145, 0.757, 1.000, 0.757, 0.145
);

DefKernel(
    "circle3",
    3, 3,
    1/9.0,
    0,
    0.569, 0.966, 0.569,
    1.000, 1.000, 1.000,
    0.569, 0.966, 0.569
);

DefKernel(
    "circle1",
    1, 1,
    1/1.0,
    0,
	0.671
);
